#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>


extern int errno;

bool myFind(char* buffer, int size, int& counter){
	counter = 0;
	while (counter < size){
		if (buffer[counter] == '\0' || buffer[counter] == '\n'){
			return true;
		}
		counter ++;
	}
	return false;
}


int myRead(int fd, char* buffer, size_t size){
	static int pos = 0;
	static char innerBuffer[256];
    int dataSize = 0;
    while (dataSize < pos){
    	buffer[dataSize] = innerBuffer[dataSize];
		if (dataSize == size - 2 || buffer[dataSize] == '\0' || buffer[dataSize] == '\n'){
			dataSize ++;
			buffer[dataSize] = '\0';
			memmove(innerBuffer, innerBuffer + dataSize, pos - dataSize);
			pos -= dataSize;
			return dataSize;
		}
		dataSize ++;
    }
    pos -= dataSize;

    while (dataSize < size && dataSize < 256 - pos){
        int ret = read(fd, buffer+dataSize, size - dataSize);
        if (ret > 0){
            printf("read something...\n");
            int counter = 0;
            bool bReturn = false;
            while (counter < ret){
				if (buffer[dataSize+counter] == '\0' || buffer[dataSize+counter] == '\n'){
					counter ++;
					bReturn = true;
					break;
				}
				counter ++;
            }
            dataSize += counter;
            if (bReturn){
				memcpy(innerBuffer+pos, buffer+dataSize, ret - counter);
				pos += ret - counter;
				break;
            }
        }else{
            if (ret <= 0 && errno == EAGAIN){
                printf("reader EAGAIN: sleep for 2 seconds...\n");
                sleep(2);
            }else{
                perror("read error");
                break;
            }
        }
    }
    return dataSize;
}

int myWrite(int fd, char* buffer, size_t size){
    int dataSize = 0;
    int ret = 0;
    while (dataSize < size){
        ret  = write(fd, buffer+dataSize, size - dataSize);
        if (ret > 0){
            dataSize += ret;
        }else{
            if (ret <= 0 && errno == EAGAIN){
                printf("write EAGAIN: sleep for 2 seconds...\n");
                sleep(2);
            }else{
                perror("write with error");
                break;
            }
        }
    }
    return dataSize;
}

int myOpen(const char* p_fifoPath){

    if (access(p_fifoPath, F_OK) == -1){
        if (mkfifo(p_fifoPath, 0x777) == -1){
            perror("cannot create fifo\n");
            return -1;
        }
    }
	if (chmod(p_fifoPath, S_IRWXU|S_IRWXG|S_IRWXO) == -1){
		perror("cannot chmod of fifo file");
	}
    int fd = -1;
    while (fd == -1){
        fd = open(p_fifoPath, O_RDWR|O_NDELAY);
        if (fd == -1){
            perror("cannot open fifo because no one running at the other end...%d\n");
            sleep(2);
        }else{
            printf("myOpen fifo fd=%d and ready...\n", fd);
        }
    }
    return fd;
}

int myScanf(char* buffer){

    scanf("%s", buffer);
    int size = strlen(buffer);
    buffer[size++]='\n';
    buffer[size]='\0';
    return size;
}


